//Lsm303d.h - Library for LSM303D Accelerometer/Magnetometer.
//Copyright (c) 2016, Julie VK3FOWL and Joe VK3YSP
//Released under the GNU General Public License.
//For more information please visit http://www.sarcnet.org
#ifndef LSM303D_H
#define LSM303D_H
#include <Arduino.h>
#include <Wire.h>
#include <EEPROM.h>
#define LSM303D_ADDRESS 0b0011101
#define LSM303D_OUT_X_L_A 0x28
#define LSM303D_OUT_X_L_M 0x08
#define LSM303D_CTRL1 0x20
#define LSM303D_CTRL2 0x21
#define LSM303D_CTRL3 0x22
#define LSM303D_CTRL4 0x23
#define LSM303D_CTRL5 0x24
#define LSM303D_CTRL6 0x25
#define LSM303D_CTRL7 0x26

class Lsm303d {
  public:
    int gx, gy, gz, mx, my, mz;
    void begin(void);
    void read(void);
  private:
    const float alpha = 0.1;  //Low pass filter damping factor - Decrease to increase damping
    int gxLast, gyLast, gzLast, mxLast, myLast, mzLast;
    int lpf(int value, int *last, float alpha);
    void reset();
    void readG();
    void readM();
    void writeReg(byte address, byte reg, byte value);
    byte readReg(byte address, byte reg);
};
#endif

